#ifndef LIBIMG_INTERNAL_H
#define LIBIMG_INTERNAL_H

/** Internal img_t flags **/

/* The surface owns its memory and got it through malloc(). Set only on
   surfaces allocated with img_create() (and thus, indirectly, img_copy()). */
#define FLAG_OWN 1
/* The surface is read-only. Set only on surfaces generated by conversion from
   fxconv, which reference data located in ROM. */
#define FLAG_RO 2

/* Null image */
#define NULL_IMG ((img_t){ 0 })

/* Check whether a surface can be used as a transform target of the specified
   size. (Defined in alloc.c.) */
int img_target(img_t img, int w, int h);

/* In-place rotation function */
void img_rotate_inplace(img_t img, int angle);

#endif /* LIBIMG_INTERNAL_H */
